# wρF_CAO`  Ver.1.24

vr_DIR="vr/" unless vr_DIR
require vr_DIR+'vruby'
require vr_DIR+'vrcontrol'
require vr_DIR+'vrcomctl'
path = File.dirname( File.expand_path( $0 ) ) + '/'
require path + 'jwui.rb'

PrefsFile = 'heron.prf'

class HeronsDialog < VRForm
	attr	:canceled
	attr	:reference
	attr	:calcTriangle
	attr	:viaHeron
	attr	:refMark,				true
	attr	:markColor,			true
	attr	:markScale,			true
	attr	:markAspect,		true
	attr	:sortHorizontal,true
	attr	:sortAscent,		true
	attr	:precision
	attr	:area_precision
	attr	:total_precision
	attr	:layer
	attr	:fontSize,				true
	attr	:fontColor,				true
	attr	:areaColor,				true
	attr	:lengthFont,			true
	attr	:lengthFontColor,	true
	attr	:lengthLayer,			true
	attr	:lengthMargin,		true
	attr	:lineColor,				true
	attr	:pathLayer,				true
	attr	:pointType,				true
	attr	:pointLayer,			true
	attr	:radius,					true
	attr	:circleColor,			true
	attr	:insideColor,			true
	attr	:insideStyle,			true
	attr	:heightColor,			true
	attr	:heightStyle,			true
	attr	:heightLayer,			true
	attr	:tableFont
	attr	:tableLayer
	attr	:subtotal
	attr	:excelFile
	attr	:excelScale
	attr	:path, true

	def show
		if @path == nil then	@path = ''	end
		create
		super
		load @path
	end

	def answer
		VRLocalScreen.messageloop

		( ! @canceled )
	end

	def drawArea?()		@draw_area		end

	def drawLength?()		@drawLength		end

	def drawLine?()		@draw_line		end

	def drawPoint?()	@draw_point		end

	def drawCircle?()				@draw_circle				end
	def drawCircle=( sw )		@draw_circle = sw		end

	def trancate?()		@trancate			end

	def round5?()			@round5				end

	def drawTable?()	@draw_table		end

	def drawExcel?()	( @draw_excel and excelFile != "" )		end

	def tableConfig
		if @viaHeron
			@tableConfig
		else
			@rectConfig
		end
	end

	def construct 
		self.caption = "w/O΋  Ver. 1.24"
		self.move(155,80,645,550)
		@canceled = true

		addControl(VRStatic,				'static1',			'ԍlF',	8,16,96,24)
		addControl(VREditCombobox,	'editReference','',						112,12,128,160)
		@editReference.setListStrings  [ "1" ]
		@editReference.select 0
		@reference = "1"

		addControl(VRButton,			'buttonMark', 	'ԍCݒ...',			440,12,160,28)
		@refMark = "ȉ~"
		@markScale = 1.0
		@markAspect = 0.7
		@markColor = "0"
		@fontSize = "0"
		@fontColor = "0"
		@areaColor = "0"
		@sortHorizontal = true
		@sortAscent = true

		addControl(VRCheckbox,	'switchArea',		'dSʒuɖʐςo',	8,48,208,24)
		@draw_area = false

		addControl(AreaTypePanel,	'switchAreaType',		'',	8,80,272,64)
		@calcTriangle = true

		addControl(CalcTypePanel,	'switchCalcType',		'',	8,152,272,64)
		@viaHeron = true

		addControl(VRStatic,		'static6',			'ӒxF',							312,56,80,24)
		addControl(VRCombobox,	'editPrecision', '',											408,52,56,100)
		addControl(VRStatic,		'staticA6',			'',											472,56,24,24)
		@editPrecision.setListStrings  [ "0", "1", "2", "3" ]
		@editPrecision.select 2
		@precision = 2

		addControl(VRStatic,		'staticB6',			'ʐϐxF',							312,88,80,24)
		addControl(VRCombobox,	'editPrecision2', '',											408,84,56,100)
		addControl(VRStatic,		'staticC6',			'',											472,88,24,24)
		@editPrecision2.setListStrings  [ "0", "1", "2", "3", "4", "5", "6", "7" ]
		@editPrecision2.select 5
		@area_precision = 5

		addControl(VRStatic,		'staticD6',			'vxF',							312,120,80,24)
		addControl(VRCombobox,	'editPrecision3', '',											408,116,56,100)
		addControl(VRStatic,		'staticE6',			'',											472,120,24,24)
		@editPrecision3.setListStrings  [ "0", "1", "2", "3", "4", "5", "6", "7" ]
		@editPrecision3.select 2
		@total_precision = 2

		addControl(VRRadiobutton,'switchNotTrancate','ľܓ',	512,56,88,24)
		addControl(VRRadiobutton,'switchTrancate','؎',					512,88,64,24)
		addControl(VRRadiobutton,'switchRound5','5Pʐ؎',			512,120,96,24)
		@switchNotTrancate.check true
		@trancate = false
		@round5 = false
		addControl(VRStatic,			'static600',	'(Ӓ̂)',			528,144,96,24)

		addControl(VRStatic,			'static3',	'CF',	256,16,72,24)
		addControl(LayerCombo,		'editLayer','',					328,12,72,220)
		@layer = "Z"
		@editLayer.select @layer

		addControl(VRCheckbox,	'switchLength',	'Ӓo',						8,232,128,24)
		@drawLength = true
		@switchLength.check true
		@lengthFont = "0"
		@lengthFontColor = "0"
		@lengthLayer = "Z"
		@lengthMargin = 0.2
		@insideColor = "0"
		@insideStyle = "2"
		@heightColor = "1"
		@heightStyle = "5"
		@heightLayer = "Z"
		addControl(VRCheckbox,	'switchLine',		'eӂč}',					8,264,128,24)
		@draw_line = false
		@lineColor = "0"
		@pathLayer = "Z"
		addControl(VRCheckbox,	'switchPoint',		'_ɓ_/~}',		200,232,152,24)
		@draw_point = false
		@pointType = "0"
		@poitLayer = "Z"
		@draw_circle = false
		@radius = 1.0
		@circleColor = "0"
		@circleLayer = "Z"

		addControl(VRButton,			'buttonAttr', 	'}ڍאݒ...',			440,232,160,28)

		addControl(VRCheckbox,	'switchTable',	'\}',		8,312,120,24)
		@draw_table = true
		addControl(VRStatic,		'static24',			'ݒt@CF',	24,348,112,24)
		addControl(VREdit,			'editTable',		'',								144,348,352,24)
		addControl(VRButton,		'buttonTable',	'Q...',				504,348,72,24)
		addControl(VRButton,		'buttonEdit',		'ҏW...',				504,372,72,24)
		@switchTable.check true
		@tableConfig = "heron.cfg"
		@rectConfig = "sansha.cfg"

		addControl(VRStatic,		'static25',				'iF',			152,312,112,24)
		addControl(FontCombo,	'editTableFont',	'',							232,308,72,220)
		@tableFont = "0"
		@editTableFont.select @tableFont
		addControl(VRStatic,		'static26',				'CF',			320,312,112,24)
		addControl(LayerCombo,	'editTableLayer',	'',							384,308,72,220)
		addControl(VRStatic,		'static107',				'j',						464,312,32,24)
		@tableLayer = "Z"
		@editTableLayer.select @tableLayer
		addControl(VRCheckbox,	'switchSubtotal',	'vo',		502,308,144,24)
		@subtotal = false

		addControl(VRCheckbox,	'switchExcel',	'GNZɏo͂',	8,400,192,24)
		@draw_excel = false
		addControl(VRStatic,		'static28',			'o̓t@CF',			24,428,112,24)
		addControl(VREdit,			'editExcel',		'',										144,428,352,24)
		addControl(VRButton,		'buttonExcel',	'Q...',						504,428,72,24)
		addControl(VRStatic,		'static1A',			'iϊkځF',				194,400,112,24)
		addControl(VREdit,			'editScale',		'1.6',								296,396,56,24)
		addControl(VRStatic,		'static108',				'j',							360,400,32,24)
		@editExcel.enabled = false
		@buttonExcel.enabled = false
		@editScale.enabled = false
		@excelFile = ""
		@excelScale = 1.6

		addControl(VRButton,	'buttonOK',			'OK',					384,476,96,32)
		addControl(VRButton,	'buttonCancel','LZ',	496,476,96,32)

		@buttonOK.focus
	end

	def editReference_changed
		@reference = @editReference.caption
	end

	def switchAreaType_changed
		@calcTriangle = @switchAreaType.calcTriangle
		if ! @calcTriangle
			@switchLine.check true
			switchLine_clicked
		end
	end

	def switchCalcType_changed
		@viaHeron = @switchCalcType.viaHeron
		if @viaHeron
			@editTable.caption = @tableConfig
		else
			@editTable.caption = @rectConfig
		end
	end

	def switchArea_clicked
		@draw_area = @switchArea.checked?
	end

	def switchLength_clicked
		@drawLength = @switchLength.checked?
	end

	def editLayer_selchanged()		@layer = @editLayer.selected		end

	def buttonMark_clicked
		@options = VRLocalScreen.newform( nil, nil, ReferenceDialog )
		@options.root = self
    @options.show
	end

	def buttonAttr_clicked
		@options2 = VRLocalScreen.newform( nil, nil, AttributeDialog )
		@options2.root = self
    @options2.show
	end

	def editReference_selchanged
		@reference = @editReference.getTextOf( @editReference.selectedString )
		@reference
	end


	def editPrecision_selchanged
		@precision = @editPrecision.getTextOf( @editPrecision.selectedString ).to_i
		@area_precision = @precision * 2 + 1
		@total_precision = @precision
		@editPrecision2.select @area_precision
		@editPrecision3.select @total_precision
	end

	def editPrecision2_selchanged
		@area_precision = @editPrecision2.getTextOf( @editPrecision2.selectedString ).to_i
	end

	def editPrecision3_selchanged
		@total_precision = @editPrecision3.getTextOf( @editPrecision3.selectedString ).to_i
	end

	def switchTrancate_clicked
		@trancate = true
		@round5 = false
	end

	def switchRound5_clicked
		@trancate = false
		@round5 = true
	end

	def switchNotTrancate_clicked
		@trancate = false
		@round5 = false
	end

	def switchLine_clicked()			@draw_line = @switchLine.checked?			end
	def switchPoint_clicked()			@draw_point = @switchPoint.checked?		end

	def switchTable_clicked
		@draw_table =  @switchTable.checked?
		@editTable.enabled = @draw_table
		@buttonTable.enabled = @draw_table
		@editTableFont.enabled = @draw_table
		@editTableLayer.enabled = @draw_table
	end

	def editTable_changed
		if @viaHeron
			@tableConfig = @editTable.caption
		else
			@rectConfig = @editTable.caption
		end
	end

	def editTableFont_selchanged()		@tableFont = @editTableFont.selected		end

	def editTableLayer_selchanged()		@tableLayer = @editTableLayer.selected	end

	def switchSubtotal_clicked()			@subtotal = @switchSubtotal.checked?		end

	def switchExcel_clicked
		@draw_excel = @switchExcel.checked?
		@editExcel.enabled = @draw_excel
		@buttonExcel.enabled = @draw_excel
		@editScale.enabled = @draw_excel
	end

	def editExcel_changed
		@excelFile = @editExcel.caption
	end

	def buttonTable_clicked
		selected = SWin::CommonDialog::openFilename(
																		self,
																		[	["ݒt@C(*.cfg)","*.cfg"],
																			["SẴt@C(*.*)","*.*"] ]
		)
    if ! selected then return end

		@editTable.caption = selected
		if @viaHeron
			@tableConfig = selected
		else
			@rectConfig = selected
		end
	end

	def buttonEdit_clicked
		system( "edit.bat " + @editTable.caption )
	end

	def buttonExcel_clicked
		selected = SWin::CommonDialog::saveFilename(
																		self,
																		[	["Excelt@C(*.xls)","*.xls"],
																			["SẴt@C(*.*)","*.*"] ]
		)
    if ! selected then return end

		@editExcel.caption = selected
		@excelFile = selected
	end

	def editScale_changed()		@excelScale = @editScale.caption.to_f		end

	def buttonOK_clicked
		if checkFiles
			@canceled = false
			save @path
			close
		end
	end

	def buttonCancel_clicked
		@canceled = true
		close
	end

	def save( path )
		prf = open( path + PrefsFile, 'w' )
		begin
			save_refs( prf )
			prf.printf "refMark = %s\n", @refMark
			prf.printf "layer = %s\n", @layer
			prf.printf "fontSize = %s\n", @fontSize
			prf.printf "fontColor = %s\n", @fontColor
			prf.printf "areaColor = %s\n", @areaColor
			prf.printf "markColor = %s\n", @markColor
			prf.printf "markScale = %f\n", @markScale
			prf.printf "markAspect = %f\n", @markAspect
			prf.printf "drawArea = %s\n", (drawArea?).to_s
			prf.printf "calcTriangle = %s\n", @calcTriangle.to_s
			prf.printf "viaHeron = %s\n", @viaHeron.to_s
			prf.printf "drawLength = %s\n", (drawLength?).to_s
			prf.printf "lengthLayer = %s\n", @lengthLayer
			prf.printf "lengthFont = %s\n", @lengthFont
			prf.printf "lengthFontColor = %s\n", @lengthFontColor
			prf.printf "lengthMargin = %f\n", @lengthMargin
			prf.printf "sort_horizontal = %s\n", @sortHorizontal.to_s
			prf.printf "sort_ascent = %s\n", @sortAscent.to_s
			prf.printf "precision = %d\n", @precision
			prf.printf "area_precision = %d\n", @area_precision
			prf.printf "total_precision = %d\n", @total_precision
			prf.printf "trancate = %s\n", @trancate.to_s
			prf.printf "round5 = %s\n", @round5.to_s
			prf.printf "drawLine = %s\n", (drawLine?).to_s
			prf.printf "lineColor = %s\n", @lineColor
			prf.printf "pathLayer = %s\n", @pathLayer
			prf.printf "insideColor = %s\n", @insideColor
			prf.printf "insideStyle = %s\n", @insideStyle
			prf.printf "heightColor = %s\n", @heightColor
			prf.printf "heightStyle = %s\n", @heightStyle
			prf.printf "heightLayer = %s\n", @heightLayer
			prf.printf "drawPoint = %s\n", (drawPoint?).to_s
			prf.printf "pointType = %s\n", @pointType
			prf.printf "pointLayer = %s\n", @pointLayer
			prf.printf "drawCircle = %s\n", (drawCircle?).to_s
			prf.printf "radius = %g\n", @radius
			prf.printf "circleColor = %s\n", @circleColor
			prf.printf "drawTable = %s\n", (drawTable?).to_s
			prf.printf "tableConfig = %s\n", @tableConfig
			prf.printf "rectConfig = %s\n", @rectConfig
			prf.printf "tableLayer = %s\n", @tableLayer
			prf.printf "tableFont = %s\n", @tableFont
			prf.printf "subtotal = %s\n", @subtotal.to_s
			prf.printf "drawExcel = %s\n", (drawExcel?).to_s
			prf.printf "excelFile = %s\n", @excelFile
			prf.printf "excelScale = %f\n", @excelScale
		ensure
			prf.close
		end
	end

	def save_refs( prf )
		refs = Array.new
		refs.push @reference

		@editReference.eachString { |ref| refs.push( ref ) }
		refs.uniq!

		if refs.length >= 10 then refs = refs[ 0..9 ] end
		idx = 0
		for ref in refs
			prf.printf "reference%d = %s\n", idx, ref
			idx += 1
		end
	end

	def load( path )
		if FileTest.exist?( path + PrefsFile )
			prf = open( path + PrefsFile, 'r' )
			begin
				while prf.gets
					chomp!
					case $_
						when /^reference([0-9]) =(.*)/
							if $1 == "0"
								@reference = $2.strip
								@editReference.clearStrings
							end
							@editReference.addString $2.strip
						when /^layer =(.*)/
							@layer = $1.strip
							@editLayer.select @layer
						when /^fontSize =(.*)/
							@fontSize = $1.strip
						when /^fontColor =(.*)/
							@fontColor = $1.strip
						when /^areaColor =(.*)/
							@areaColor = $1.strip
						when /^refMark =(.*)/
							@refMark = $1.strip
						when /^markColor =(.*)/
							@markColor = $1.strip
						when /^markScale =(.*)/
							@markScale = $1.to_f
						when /^markAspect =(.*)/
							@markAspect = $1.to_f
						when /^drawArea =(.*)/
							@switchArea.check ( $1 =~ /true/ )
							switchArea_clicked
						when /^calcTriangle =(.*)/
							@calcTriangle = ( $1 =~ /true/ ? true : false )
							@switchAreaType.calcTriangle @calcTriangle
						when /^viaHeron =(.*)/
							if $1 =~ /true/
								@viaHeron = true
								@editTable.caption = @tableConfig
							else
								@viaHeron = false
								@editTable.caption = @rectConfig
							end
							@switchCalcType.viaHeron @viaHeron
						when /^drawLength =(.*)/
							@switchLength.check ( $1 =~ /true/ )
							switchLength_clicked
						when /^lengthFont =(.*)/
							@lengthFont = $1.strip
						when /^lengthFontColor =(.*)/
							@lengthFontColor = $1.strip
						when /^lengthLayer =(.*)/
							@lengthLayer = $1.strip
						when /^lengthMargin =(.*)/
							@lengthMargin = $1.to_f
						when /^sort_horizontal =(.*)/
							@sortHorizontal = ( $1 =~ /true/ ? true : false )
						when /^sort_ascent =(.*)/
							@sortAscent = ( $1 =~ /true/ ? true : false )
						when /^precision =(.*)/
							@precision = $1.to_i
							@editPrecision.select( @precision )
							@total_precision = @precision
							@editPrecision3.select( @total_precision )
						when /^area_precision =(.*)/
							@area_precision = $1.to_i
							@editPrecision2.select( @area_precision )
						when /^total_precision =(.*)/
							@total_precision = $1.to_i
							@editPrecision3.select( @total_precision )
						when /^trancate =(.*)/
							@switchTrancate.check ($1 =~ /true/)
							if @switchTrancate.checked?
								@switchNotTrancate.check false
								switchTrancate_clicked
							else
								switchNotTrancate_clicked
							end
						when /^round5 =(.*)/
							@switchRound5.check ($1 =~ /true/)
							if @switchRound5.checked?
								switchRound5_clicked
								@switchNotTrancate.check false
							end
						when /^drawLine =(.*)/
							@switchLine.check ($1 =~ /true/ )
							switchLine_clicked
						when /^lineColor =(.*)/
							@lineColor = $1.strip
						when /^pathLayer =(.*)/
							@pathLayer = $1.strip
						when /^insideColor =(.*)/
							@insideColor = $1.strip
						when /^insideStyle =(.*)/
							@insideStyle = $1.strip
						when /^heightColor =(.*)/
							@heightColor = $1.strip
						when /^heightStyle =(.*)/
							@heightStyle = $1.strip
						when /^heightLayer =(.*)/
							@heightLayer = $1.strip
						when /^drawPoint =(.*)/
							@switchPoint.check ($1 =~ /true/ )
							switchPoint_clicked
						when /^pointType =(.*)/
							@pointType = $1.strip
						when /^pointLayer =(.*)/
							@pointLayer = $1.strip
						when /^drawCircle =(.*)/
							@draw_circle = ($1 =~ /true/ ? true : false)
							if @draw_circle
								@switchPoint.check true
								switchPoint_clicked
							end
						when /^radius =(.*)/
							@radius = $1.to_f
						when /^circleColor =(.*)/
							@circleColor = $1.strip
						when /^drawTable =(.*)/
							@switchTable.check ($1 =~ /true/ )
							switchTable_clicked
						when /^tableConfig =(.*)/
							@tableConfig = $1.strip
							if @viaHeron then		@editTable.caption = @tableConfig		end
						when /^rectConfig =(.*)/
							@rectConfig = $1.strip
							if ! @viaHeron then		@editTable.caption = @rectConfig	end
						when /^tableLayer =(.*)/
							@tableLayer = $1.strip
							@editTableLayer.select @tableLayer
						when /^tableFont =(.*)/
							@tableFont = $1.strip
							@editTableFont.select( @tableFont.to_i )
						when /^subtotal =(.*)/
							@switchSubtotal.check ($1 =~ /true/ )
							switchSubtotal_clicked
						when /^drawExcel =(.*)/
							@switchExcel.check ($1 =~ /true/)
							switchExcel_clicked
						when /^excelFile =(.*)/
							@excelFile = $1.strip
							@editExcel.caption = @excelFile
						when /^excelScale =(.*)/
							@excelScale = $1.to_f
							@editScale.caption = @excelScale.to_s
					end
				end
				@editReference.select 0
			ensure
				prf.close
			end
		end
	end

	def checkFiles()
		if @switchTable.checked?
			result = true
			if @editTable.caption == ""
				messageBox '\ݒt@Cw肵ĂB',"gHeron",0
				result = false
			elsif ! FileTest.exist? @tableConfig
				messageBox '\ݒt@C ' + @tableConfig + ' ܂B',"gHeron",0
				result = false
			end
			result
		else
			true
		end
	end
end

class AreaTypePanel < VRPanel
  include VRComCtlContainer
  include VRStdControlContainer

	def construct
		addControl(	VRStatic,				'static1',				'~n`ԁF',		0,8,80,24)
		addControl(	VRRadiobutton,	'switchTriangle',	'Op`̏W',	88,8,120,24)
		addControl(	VRRadiobutton,	'switchSolid',		'\bh}`',	88,40,120,24)
		@switchTriangle.check true
		@isTriangle = true
	end

	def calcTriangle( *sw )
		if sw.length > 0
			@isTriangle = sw[0]
			@switchTriangle.check @isTriangle
			@switchSolid.check (! @isTriangle)
		end

		@isTriangle
	end

	def enabled=(sw)
		@switchTriangle.enabled = sw
		@switchSolid.enabled = sw
	end

	def switchTriangle_clicked
		@isTriangle = @switchTriangle.checked?
		call_parenthandler 'changed'
	end

	def switchSolid_clicked
		@isTriangle = @switchTriangle.checked?
		call_parenthandler 'changed'
	end
end

class CalcTypePanel < VRPanel
  include VRComCtlContainer
  include VRStdControlContainer

	def construct
		addControl(	VRStatic,				'static1',				'ϖ@F',		0,8,80,24)
		addControl(	VRRadiobutton,	'switchHeron',		'w',	88,8,120,24)
		addControl(	VRRadiobutton,	'switchDouble',		'{ʐϖ@iӁ~j',	88,40,200,24)
		@switchHeron.check true
		@viaHeron = true
	end

	def viaHeron( *sw )
		if sw.length > 0
			@viaHeron = sw[0]
			@switchHeron.check @viaHeron
			@switchDouble.check (! @viaHeron)
		end

		@viaHeron
	end

	def switchHeron_clicked
		@viaHeron = @switchHeron.checked?
		call_parenthandler 'changed'
	end

	def switchDouble_clicked
		@viaHeron = @switchHeron.checked?
		call_parenthandler 'changed'
	end
end


class ReferenceDialog < VRForm
	attr	:root,		true

	def show
		create	if @canceled == nil
		super
		load
	end

	def construct
		self.caption = "w/O΋ - ~nԍCݒ"
		self.move(180,160,420,320)
		@canceled = true

		addControl(VRStatic,				'static1',			'LF',	8,18,96,24)
		addControl(VRCombobox,			'editRefMark', '',						104,16,80,100)
		@editRefMark.setListStrings [ "ȉ~", "~" ]
		@editRefMark.select 0
		@refMark = "ȉ~"

		addControl(VRStatic,				'static2',			'LTCYkځF',	216,18,128,24)
		addControl(VREdit,					'editScale',		'1.0',							344,16,56,24)

		addControl(VRStatic,				'static3',			'ȉ~GF',			216,50,128,24)
		addControl(VREdit,					'editAspect',		'0.7',							344,48,56,24)

		addControl(VRStatic,				'static4',			'LFF',				8,82,128,24)
		addControl(ColorCombo,			'editColor',		'',									112,80,72,220)
		@lineColor = "0"
		@editColor.select @lineColor

		addControl(VRStatic,				'static5',			'TCYF',			8,114,128,24)
		addControl(FontCombo,				'editFont',			'',									112,112,72,220)
		@font = "0"
		@editFont.select @font
		addControl(VRStatic,				'static6',			'ԍFF',			216,114,128,24)
		addControl(ColorCombo,			'editFontColor','',									320,112,72,220)
		addControl(VRStatic,				'static7',			'ʐϕFF',			216,146,128,24)
		addControl(ColorCombo,			'editAreaColor','',									320,144,72,220)
		@fontColor = "0"
		@editFontColor.select @fontColor

		addControl(VRStatic,				'static8',			'UtF',					8,186,128,24)
		addControl(	VRRadiobutton,	'switchLeft',		'E',						112,186,80,24)
		addControl(	VRRadiobutton,	'switchRight',	'E',						200,186,80,24)
		addControl(	VRRadiobutton,	'switchTop',		'と',						112,210,80,24)
		addControl(	VRRadiobutton,	'switchBottom',	'',						200,210,80,24)

		addControl(VRButton,	'buttonOK',			'OK',					194,248,96,32)
		addControl(VRButton,	'buttonCancel','LZ',	304,248,96,32)
	end

	def editRefMark_selchanged
		@refMark = @editRefMark.getTextOf( @editRefMark.selectedString )
		if @refMark == 'ȉ~'
			@editAspect.enabled = true
		else
			@editAspect.enabled = false
		end
	end

	def buttonOK_clicked
		save
		close
	end

	def buttonCancel_clicked
		@canceled = true
		close
	end

	def load
		if @root.refMark == "ȉ~"
			@editRefMark.select 0
		elsif @root.refMark == "~"
			@editRefMark.select 1
		end
		editRefMark_selchanged

		@editScale.caption = @root.markScale.to_s
		@editAspect.caption = @root.markAspect.to_s
		@editColor.select @root.markColor
		@editFont.select @root.fontSize
		@editFontColor.select @root.fontColor
		@editAreaColor.select @root.areaColor

		@switchLeft.check		(@root.sortHorizontal & @root.sortAscent)
		@switchRight.check	(@root.sortHorizontal & (! @root.sortAscent) )
		@switchTop.check		( (! @root.sortHorizontal) & (! @root.sortAscent) )
		@switchBottom.check	( (! @root.sortHorizontal) & @root.sortAscent)
	end

	def save
		@root.refMark = @editRefMark.getTextOf( @editRefMark.selectedString )
		@root.markScale = @editScale.caption.to_f
		@root.markAspect = @editAspect.caption.to_f
		@root.markColor = @editColor.selected
		@root.fontSize = @editFont.selected
		@root.fontColor = @editFontColor.selected
		@root.areaColor = @editAreaColor.selected

		@root.sortHorizontal =	( (@switchLeft.checked? or @switchRight.checked?) ? true : false )
		@root.sortAscent =			( (@switchLeft.checked? or @switchBottom.checked?) ? true : false )
	end
end

class AttributeDialog < VRForm
	attr	:root,		true

	def show
		create	if @canceled == nil
		super
		load
	end

	def construct
		self.caption = "w/O΋ - }ڍאݒ"
		self.move(180,160,656,332)
		@canceled = true

		addControl(VRStatic,	'static1',	'Ӓ',						8,18,128,24)
		addControl(VRStatic,	'static2',	'F',						152,18,72,24)
		addControl(FontCombo,	'editLengthFont',	'',							232,16,72,220)
		addControl(VRStatic,	'static3',		'FF',					320,18,80,24)
		addControl(ColorCombo,'editFontColor','',								400,16,72,220)

		addControl(VRStatic,			'static4',			'CF',		504,18,72,24)
		addControl(LayerCombo,		'editLengthLayer','',					568,16,72,220)
		addControl(VRStatic,	'static5',	'F',							152,50,72,24)
		addControl(VREdit,		'editLengthMargin',	'',						232,48,72,24)
		addControl(VRStatic,	'static6',	'i}Fmmj',				304,50,120,24)

		addControl(VRStatic,	'static7',		'ӂ̍č}',				8,90,128,24)
		addControl(VRStatic,	'static8',		'O`FF',				152,90,80,24)
		addControl(ColorCombo,'editLineColor','',								232,88,72,220)
		addControl(VRStatic,	'static9',			'CF',				320,90,72,24)
		addControl(LayerCombo,'editPathLayer',	'',							400,88,72,220)
		addControl(VRStatic,	'static10',		'אڐFF',				152,122,80,24)
		addControl(ColorCombo,'editInsideColor','',							232,120,72,220)
		addControl(VRStatic,	'static11',			'אڐF',			320,122,88,24)
		addControl(LineCombo,'editInsideStyle','',							400,120,88,220)

		addControl(VRStatic,	'static12',			'o',			8,162,144,24)
		addControl(VRStatic,	'static13',			'F@@F',			152,162,144,24)
		addControl(ColorCombo,'editHeightColor','',							232,160,72,220)
		addControl(VRStatic,	'static14',			'@@F',			320,162,144,24)
		addControl(LineCombo,	'editHeightStyle','',							400,160,88,220)
		addControl(VRStatic,	'static15',			'CF',				504,162,72,24)
		addControl(LayerCombo,'editHeightLayer','',							568,160,72,220)

		addControl(VRStatic,	'static16',			'_̍}',			8,200,144,24)
		addControl(VRStatic,	'static17',			'_@F',				152,200,80,24)
		addControl(PointPanel,'editPointType','',								232,198,376,24)
		addControl(VRStatic,	'static18',			'CF',				152,232,72,24)
		addControl(LayerCombo,	'editPointLayer',	'',						232,230,72,220)

		addControl(VRButton,	'buttonOK',			'OK',					416,272,96,32)
		addControl(VRButton,	'buttonCancel','LZ',	526,272,96,32)
	end

	def buttonOK_clicked
		save
		close
	end

	def buttonCancel_clicked
		@canceled = true
		close
	end

	def load
		@editLengthFont.select @root.lengthFont
		@editLengthLayer.select @root.lengthLayer
		@editFontColor.select @root.lengthFontColor
		@editLengthMargin.caption = @root.lengthMargin.to_s
		if ! @root.drawLength?
			@editLengthFont.enabled = false
			@editFontColor.enabled = false
			@editLengthLayer.enabled = false
			@editLengthMargin.enabled = false
		end
		@editLineColor.select @root.lineColor
		@editPathLayer.select @root.pathLayer
		@editInsideColor.select @root.insideColor
		@editInsideStyle.select @root.insideStyle
		if ! @root.drawLine?
			@editLineColor.enabled = false
			@editPathLayer.enabled = false
			@editInsideColor.enabled = false
			@editInsideStyle.enabled = false
		end
		@editHeightColor.select @root.heightColor
		@editHeightStyle.select @root.heightStyle
		@editHeightLayer.select @root.heightLayer
		if @root.viaHeron
			@editHeightColor.enabled = false
			@editHeightStyle.enabled = false
			@editHeightLayer.enabled = false
		end
		@editPointLayer.select @root.pointLayer
		if @root.drawCircle?
			@editPointType.pointColor = "C"
		else
			@editPointType.pointColor = @root.pointType
		end
		if ! @root.drawPoint?
			@editPointLayer.enabled = false
			@editPointType.enabled = false
		end
		@editPointType.circleColor = @root.circleColor
		@editPointType.radius = @root.radius.to_s
	end

	def save
		@root.lengthFont = @editLengthFont.selected
		@root.lengthFontColor = @editFontColor.selected
		@root.lengthLayer = @editLengthLayer.selected
		@root.lengthMargin = @editLengthMargin.caption.to_f
		@root.lineColor = @editLineColor.selected
		@root.pathLayer = @editPathLayer.selected
		@root.insideColor = @editInsideColor.selected
		@root.insideStyle = @editInsideStyle.selected
		@root.heightColor = @editHeightColor.selected
		@root.heightStyle = @editHeightStyle.selected
		@root.heightLayer = @editHeightLayer.selected
		@root.pointLayer = @editPointLayer.selected
		if @editPointType.pointColor == "C"
			@root.drawCircle = true
			@root.circleColor = @editPointType.circleColor
			@root.radius = @editPointType.radius
		else
			@root.drawCircle = false
			@root.pointType = @editPointType.pointColor
		end
	end
end
